package org.diagbot.graph.util;

import org.apache.commons.lang3.StringUtils;
import org.diagbot.nlp.participle.cfg.Configuration;
import org.diagbot.nlp.participle.cfg.DefaultConfig;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class CacheUtil {
    public static Map<String,String> lexionMap=null;
    public static Map<String,Map<String,String>> sexAgeMap=null;
    public static Map<String,String> vitalMap=null;
    public static Map<String,String> disgSortMap=null;
    public static Map<String,String> diagClassifyMap = null;
    public static Map<String,Integer> diagClassifyJiMap = null;
    //诊断科室衍射
    public static Map<String, String> doc_result_mapping_diag_map = null;

    //疾病科室，获取缓存
    public static Map<String,String> getDiagDepartCache(){
        String path = "doc_result_mapping_diag.dict";
        Configuration configuration = new DefaultConfig();
        if(doc_result_mapping_diag_map == null){
            doc_result_mapping_diag_map = new HashMap<>();
            List<String> contentList = configuration.readFileContents(path);
            for (String s:contentList) {
                String[] splits = s.split("\\|");
                doc_result_mapping_diag_map.put(splits[0],splits[1]);
            }
        }
        return doc_result_mapping_diag_map;
    }

    //疾病分级解析，获取缓存
    public static Map<String,Integer> getDiagClassifyJiCache(){
        String path = "diagClassify.dict";
        Configuration configuration = new DefaultConfig();
        if(diagClassifyJiMap == null){
            diagClassifyJiMap = new HashMap<>();
            List<String> contentList = configuration.readFileContents(path);
            String diagName =null,bigdiagName=null;
            String[] diagSort =null;
            for (String s:contentList) {
                String[] splits = s.split("\\|");
                if (splits.length >= 2) {
                    diagName = splits[0].trim();//疾病本体
                    bigdiagName = splits[1].trim();//疾病大类
                    diagClassifyJiMap.put(bigdiagName, 2);
                    diagClassifyJiMap.put(diagName,1);
                    if (splits.length == 3) {
                        diagSort = splits[2].split("\\、");
                        for (String dis : diagSort) {
                            if (StringUtils.isNotEmpty(dis.trim())) {
                                diagClassifyJiMap.put(dis.trim(), 3);
                            }
                        }
                    }
                }
            }
        }
        return diagClassifyJiMap;
    }
    //疾病归一解析，获取缓存
    public static Map<String,String> getDiagClassifyCache(){
        String path = "diagClassify.dict";
        Configuration configuration = new DefaultConfig();
        if(diagClassifyMap == null){
            diagClassifyMap = new HashMap<>();
            List<String> contentList = configuration.readFileContents(path);
            String diagName =null,bigdiagName=null;
            String[] diagSort =null;
            for (String s:contentList) {
                String[] splits = s.split("\\|");
                if (splits.length >= 2) {
                    diagName = splits[0].trim();//疾病本体
                    bigdiagName = splits[1].trim();//疾病大类
                    diagClassifyMap.put(bigdiagName, diagName);
                    if (splits.length == 3) {
                        diagSort = splits[2].split("\\、");
                        for (String dis : diagSort) {
                            if (StringUtils.isNotEmpty(dis.trim())) {
                                diagClassifyMap.put(dis.trim(), bigdiagName);
                            }
                        }
                    }
                }
            }
        }
        return diagClassifyMap;
    }

    public static Map<String,String> getDiagSortCache(){
        String path = "diagSort.dict";
        Configuration configuration = new DefaultConfig();
        if(disgSortMap == null){
            disgSortMap = new HashMap<>();
            List<String> contentList = configuration.readFileContents(path);
            for (String s:contentList) {
                String[] splits = s.split("\\|");
                String diagName = splits[0];
                String diagType = splits[1];
                disgSortMap.put(diagName,diagType);
            }
        }
        return disgSortMap;
    }
    public static Map<String,String> getLexionCache(){
        String path = "lexicon.dict";
        Configuration configuration = new DefaultConfig();
        if(lexionMap == null){
            lexionMap = new HashMap<>();
            List<String> contentList = configuration.readFileContents(path);
            for (String s:contentList) {
                String[] splits = s.split("\\|");
                lexionMap.put(splits[0],splits[1]);
            }

        }
        return lexionMap;
    }
    public static Map<String,Map<String,String>> getSexAgeCache(){
        String path = "sexAge.dict";
        Configuration configuration = new DefaultConfig();
        if(sexAgeMap == null){
            sexAgeMap = new HashMap<>();
            List<String> contentList = configuration.readFileContents(path);
            for (String s:contentList) {
                Map<String,String> contentMap = new HashMap<>();
                String[] splits = s.split("\\|");
                String sexTyep = splits[1];
                String min_age = splits[2];
                String max_age = splits[3];
                contentMap.put("sexType",sexTyep);
                contentMap.put("min_age",min_age);
                contentMap.put("max_age",max_age);
                sexAgeMap.put(splits[0],contentMap);
            }
        }
        return sexAgeMap;
    }
    public static Map<String,String> getVitalCache(){
        String path = "vital.dict";
        Configuration configuration = new DefaultConfig();
        if(vitalMap == null){
            vitalMap = new HashMap<>();
            List<String> contentList = configuration.readFileContents(path);
            for (String s:contentList) {
                String[] splits = s.split("\\|");
                vitalMap.put(splits[0],splits[1]);
            }
        }
        return vitalMap;
    }
}
